import processing.serial.*;
import controlP5.*;
import java.util.*;

ControlP5 cp5;
List lt = Arrays.asList("Run", "Stop");


Serial dport;
int nblocks,nbytes,nsamples, nfft,p_clk, f_run;

byte[] raw_data = new byte[100000];
float[] ch0 = new float[100000];
float[] ch_real = new float[100000];
float[] ch_imag = new float[100000];
float[] ch_pow = new float[100000];
float max_freq,freq_inc;
int currenty;
color[] cmap = new color[1000];
int ncmap;

public void colorA(int theValue) 
{
  println("a button event from colorA: "+theValue);

    
}

public void controlEvent(ControlEvent theEvent) 
{
  println(theEvent.getController().getName());
if (theEvent.getController().getName() == "Run")  f_run = 1;
if (theEvent.getController().getName() == "Stop")  f_run = 0;
if (theEvent.getController().getName() == "5kHz")    dport.write("a");
if (theEvent.getController().getName() == "25kHz")   dport.write("b");
if (theEvent.getController().getName() == "100kHz")   dport.write("c");
if (theEvent.getController().getName() == "500kHz")   dport.write("e");

if (theEvent.getController().getName() == "512")   dport.write("g");
if (theEvent.getController().getName() == "2k")   dport.write("h");
if (theEvent.getController().getName() == "8k")   dport.write("i");
}

void setup()
  {
    float t;
    int i,j,k,m;
    color c;
    size(1200,1000); 
    
    cp5 = new ControlP5(this);  
    cp5.addButton("Run").setValue(0).setPosition(0,100).setSize(50,19);
    cp5.addButton("Stop").setValue(0).setPosition(0,150).setSize(50,19); 
    cp5.addButton("5kHz").setValue(0).setPosition(0,400).setSize(50,19);  
    cp5.addButton("25kHz").setValue(0).setPosition(0,420).setSize(50,19);  
    cp5.addButton("100kHz").setValue(0).setPosition(0,440).setSize(50,19);   
    cp5.addButton("500kHz").setValue(0).setPosition(0,460).setSize(50,19); 
    cp5.addButton("512").setValue(0).setPosition(0,300).setSize(50,19);
    cp5.addButton("2k").setValue(0).setPosition(0,320).setSize(50,19);
    cp5.addButton("8k").setValue(0).setPosition(0,340).setSize(50,19);
    dport = new Serial(this,"COM9",250000);

    
    dport.write("p");
    while (dport.available() < 1)
      print(".");
    p_clk = dport.read();
    
    
    nblocks = 8;
    nbytes = nblocks * 2 * 256;        // 256 x nblocks of 12 bit samples in due code = 2 x 256 x nblocks of bytes sent
    nsamples = nblocks * 256;
    nfft = nsamples/2;
    max_freq = 1e6 / (0.0 + (float)(p_clk+1));      // need 0.047 for extra time in ADC conversion                   
    freq_inc = max_freq/10.0;
    
    currenty = (int)(height * 0.9);
    background(0);
    colorMode(HSB,255);
    i=0;
    m=0;
     for (j=0; j < 22; j++)
      {
        k = j*10 + 50;
        if (k > 255) k = 255;
        m =  j*10 +200;
        c = color(m % 256,255,k);
        cmap[i++] = c;
        cmap[i++] = c;
      }   
     c = color(m % 256,0,255);
     cmap[i++] = c; 
     c = color(0,255,255);
     cmap[i++] = c; 
    ncmap = i;
    f_run = 1;
  }
  
  
  
void draw()
  {
    if (f_run ==1)
      do_it();
  }
  
void do_it()
  {
  int i,j,b1,b2,p,p2;
  float x,y,oldx,oldy; 
  
  dport.write("p");
    while (dport.available() < 1)
      print(".");
    p_clk = dport.read();
  max_freq = 1e6 / (0.0 + (float)(p_clk+1));      // need 0.047 for extra time in ADC conversion                   
    freq_inc = max_freq/10.0;  
    
  dport.write("d");
  
  loadPixels();
  for(i = 950; i >= 550; i--)
      {
        p  = width * i;
        p2 = width * (i-1);
        for(j = 0; j < width; j++)
          {
            pixels[p+j] = pixels[p2+j];
          }
      }

  while (dport.available() < (nbytes-1))
    {
    print();          // need this for the loop to work.
    }  
  dport.readBytes(raw_data);  
 
  
  for(i = 0,j=0; i < nbytes; i+= 2,j++)
    {
      b1 = raw_data[i] < 0 ? 256 + raw_data[i] : raw_data[i];        // byte is 8 bit signed. need unsigned
      b2 = raw_data[i+1] < 0 ? 256 + raw_data[i+1] : raw_data[i+1];
      ch0[j] =(float)(b2) + ((float)b1)/256.0; 
      ch0[j] /= 8.0; 
    }

    window(2,ch0,ch_real,ch_imag,nsamples);
    fft( ch_real,ch_imag,true,ch_pow,nsamples);
    

    stroke(255,0,0);
    float sx, sy,ox,oy,db,max1,f;
    ox = width * 0.1;
    sx = width * 0.8;
    oy = 450;
    sy = -400;


    colorMode(HSB,255);
    color c;  
    for (i=0; i < nfft; i++)
      {
        x = ox + sx * (float)i / (float)nfft;
        j =  (int)( (float)ncmap * (ch_pow[i] + 0.23) );
        if (j > ncmap) j = ncmap;
        if (j < 0) j = 0;
        c = cmap[j];
        p = (550) * width + (int)x;
        pixels[p]  = c;
      }
    updatePixels();
    colorMode(RGB,255);
    stroke(0,0,0);
    fill(0);
    rect(0,0,width,500);
    noFill();
    fill(255);
    textSize(15);
    
    for(i = 450; i > 50; i--)
      {
        j = 450 - i;
       x = (float)ncmap * (float)j / 400.0; 
       stroke(cmap[(int)x]); 
       y = i;
       line (ox+sx+10,y,ox+sx+40,y);
      }
    
    
    stroke(90,0,0);
    for (db = -20.0; db <= 80.01; db += 2.0)
      {
       y = oy +  sy *( (db + 20) / 100);
       line ( ox, y,ox+sx,y);
      }
    stroke(150,0,0);  
    for (db = -20.0; db <= 80.01; db += 10.0)
      {
       y = oy +  sy *( (db + 20) / 100);
       line ( ox, y,ox+sx,y);
       text((int)(db - 70) + "db",ox - 50,y + 5); 
      }
    stroke(0,90,0);
    for(f = freq_inc/5.0; f <= (max_freq * 1.01); f += freq_inc/5.0)
      {
        x = ox + sx * f/max_freq;
        line (x,oy,x,oy+sy);
      }   
    stroke(0,150,0);
    for(f = freq_inc; f <= (max_freq * 1.05); f += freq_inc)
      {
        x = ox + sx * f/max_freq;
        line (x,oy,x,oy+sy);
        pushMatrix();
        translate(x-7.0,oy+7.0);
        rotate(1.57);
        text ((int)f,0.0,0.0);
        popMatrix();
      }
    stroke(255,255,255);
    oldx = ox;
    oldy = oy + sy *(ch_pow[0]);
    max1 = 0.0;
    for(i = 0; i < nfft; i++)
      {
        x = ox + sx * ((float)i / (float)nfft);
        y = oy + sy * ( ch_pow[i] + 0.23);
        line(oldx,oldy,x,y);
        oldx = x;
        oldy = y;
        //if (i > 5 && max1 < ch_pow[i]) max1 = ch_pow[i];
      }      
    
}
  
  
  
 void window(int t,float[] v, float sar[], float sai[], int ns)
    {
    int i;
    float b,c;
    if(t == 1)
      for(i=1; i< ns; i++)
       {
       sai[i]=0.0;
       c = 2.0 * (float)i / (float) ns;
       b = 0.42 - 0.5 * cos(3.14159 * c) + 0.08 * cos(2.0 * 3.14159 * c);  //Blackman window, inexact
       sar[i] = v[i]*b;
       }  
    if(t == 2)
      for(i=1; i< ns; i++)
       {
       sai[i]=0.0;
       c = 2.0 * (float)i / (float) ns;
       b = 0.35875 - 0.48829 * cos(3.14159 * c) + 0.14128 * cos(2.0 * 3.14159 * c) - 0.01168  * cos(3.0 * 3.14159 * c);
       //Blackman-Harris window, 4 terms
       sar[i] = v[i]*b;
       }  
     }
  
  
  void fft( float[] inputReal, float[] inputImag, boolean DIRECT, float fftpow[], int n) 
   {
    // - n is the dimension of the problem
    // - nu is its logarithm in base e
    int nu,i;

    if ( (n != 0) && ((n & (n - 1)) == 0) )
      {
        // good to go with fft
        // get log 2 of n
        nu=0;
        i=1;
        while (n > i)
          {
            i += i;
            nu++;
          }
      
    }
    else
      {
        print(" fft size not power of 2 " + n);
      return;
      }
    // Declaration and initialization of the variables
    // ld should be an integer, actually, so I don't lose any information in
    // the cast
    
    int n2 = n / 2;
    int nu1 = nu - 1;
    float[] xReal = new float[n];
    float[] xImag = new float[n];
    float tReal, tImag, p, arg, c, s;

    // Here I check if I'm going to do the direct transform or the inverse
    // transform.
    float constant;
    if (DIRECT)
        constant = -2 * (float)Math.PI;
    else
        constant = 2 * (float)Math.PI;

    // I don't want to overwrite the input arrays, so here I copy them. This
    // choice adds \Theta(2n) to the complexity.
    for (i = 0; i < n; i++) {
        xReal[i] = inputReal[i];
        xImag[i] = inputImag[i];
    }

    // First phase - calculation
    int k = 0;
    for (int l = 1; l <= nu; l++) {
        while (k < n) {
            for ( i = 1; i <= n2; i++) {
                p = bitreverseReference(k >> nu1, nu);
                // direct FFT or inverse FFT
                arg = constant * p / n;
                c = (float)Math.cos(arg);
                s = (float)Math.sin(arg);
                tReal = xReal[k + n2] * c + xImag[k + n2] * s;
                tImag = xImag[k + n2] * c - xReal[k + n2] * s;
                xReal[k + n2] = xReal[k] - tReal;
                xImag[k + n2] = xImag[k] - tImag;
                xReal[k] += tReal;
                xImag[k] += tImag;
                k++;
            }
            k += n2;
        }
        k = 0;
        nu1--;
        n2 /= 2;
    }

    // Second phase - recombination
    k = 0;
    int r;
    while (k < n) {
        r = bitreverseReference(k, nu);
        if (r > k) {
            tReal = xReal[k];
            tImag = xImag[k];
            xReal[k] = xReal[r];
            xImag[k] = xImag[r];
            xReal[r] = tReal;
            xImag[r] = tImag;
        }
        k++;
    }


   float m,t,radice = 1.0 / (float) n;
   for( i=0; i < n; i++)
     {
       m = (float) (radice * Math.sqrt(xReal[i]*xReal[i] + xImag[i]*xImag[i]));    
       t = (float)Math.log(m)/(float)Math.log(10.0);
       t = 1.0 + 0.2*t;
       if(t < -0.23) t = -0.23;
       fftpow[i] = t; 
     }
}

/**
 * The reference bitreverse function.
 */
int bitreverseReference(int j, int nu) {
    int j2;
    int j1 = j;
    int k = 0;
    for (int i = 1; i <= nu; i++) {
        j2 = j1 / 2;
        k = 2 * k + j1 - 2 * j2;
        j1 = j2;
    }
    return k;
  }
  
